<template>
  <v-text-field
    :hint="hint"
    :label="label"
    :color="color"
    :error="error"
    :rules="rules"
    v-model="model"
    :variant="variant"
    base-color="onSurfaceVariant"
    hide-details="auto"
    :disabled="disabled"
    :clearable="clearable"
    :autofocus="autofocus"
    :placeholder="placeholder"
    :persistent-hint="persistentHint"
    :prepend-inner-icon="prependInnerIcon"
    :append-inner-icon="appendInnerIcon"
    :messages="messages"
    :counter="counter"
    :error-messages="errorMessages"
    :persistent-counter="persistentCounter"
    :maxlength="maxLength"
    @update:model-value="update"
    @click:clear="clear"
  >
    <template v-if="counter && persistentCounter" #counter="{ value }"> {{ (maxLength || 0) - value }} </template>

    <template #append v-if="append">
      <slot name="append" />
    </template>
  </v-text-field>
</template>

<script setup>
import { ref, watch, onMounted } from 'vue';

const props = defineProps({
  label:{
    type: String,
    default: '',
  },
  appendInnerIcon:{
    type: String,
    default: undefined,
  },
  messages: {
    type: String,
    default: undefined,
  },
  prependInnerIcon:{
    type: String,
    default: '',
  },
  variant:{
    type: String,
    default: "outlined",
  },
  autofocus:{
    type: Boolean,
    default: false,
  },
  append: {
    type: Boolean,
    default: false,
  },
  clearable:{
    type: Boolean,
    default: false,
  },
  color: {
    type: String,
    default: 'primary',
  },
  disabled: {
    type: Boolean,
    default: false,
  },
  hint: {
    type: String,
    default: undefined,
  },
  error: {
    type: Boolean,
    default: false,
  },
  errorMessages: {
    type: String,
    default: undefined,
  },
  persistentHint: {
    type: Boolean,
    default: false,
  },
  placeholder: {
    type: String,
    default: undefined,
  },
  counter: {
    type: Boolean,
    default: false,
  },
  persistentCounter: {
    type: Boolean,
    default: false,
  },
  maxLength: {
    type: Number,
    default: undefined,
  },
  modelValue:{
    type: undefined,
    default: null,
  },
  rules: {
    type: Array,
    default: () => [],
  }
})

const emit = defineEmits(['update:modelValue', 'clear'])

onMounted(() => {
  model.value = props?.modelValue
});

const model = ref(null);

const update = () => {
  emit('update:modelValue', model?.value)
}

const clear = () => {
  emit('clear');
}

watch(props, (newValue, oldValue) => {
  if (newValue?.modelValue) {
    model.value = newValue?.modelValue
  }
})
</script>